<%-
require 'open3'
begin
    # Command to Run
    script = '/opt/slurm/bin/sinfo -h --format="%P"'
    # Create a partitions array to dynamically populate the queues associated with the user
    partitions = []
    # Store the output, error, status
    output, status = Open3.capture2('bash', stdin_data: script)
    # puts status
    if status.success?
        # Add it to the custom_envs array by splitting the output at '\n'. 
        output.split("\n").each do |queue|
            if queue != 'backfill'
                queue = queue.gsub("*", "")
                partitions.push(queue)
            end
        end
        puts partitions
    else
        partition_error = "Error"
    end
rescue => e
    partition_error = e.message.strip
end
-%>
---
cluster: "dcc"
form:
  - custom_queue
  - bc_num_hours
  - bc_num_slots
  - num_cpus
  - num_mem
  - num_gpus
  - email
  - singularity_img
submit: submit.yml.erb
id: submitForm
name : submitForm
title: RStudio Browser
attributes:
  custom_queue:
    id: custom_queue
    label: Partition
    widget: select
    cacheable: false
    help: |
      - [Partition Documentation](https://hpc.nmsu.edu/discovery/home/partitions/)
    <%- if partition_error || partitions.blank?-%>   
      <div class="text-danger">Error while fetching Partition. Please contact support!</div>
    <%- else -%>
    options:
    <%- partitions.each do |q| -%>
      - [ "<%= q %>", "<%= q %>" ]
    <%- end -%>
    <%- end -%>
  bc_num_hours:
    id: bc_num_hours
    label: Walltime (Hours)
    help: |
      - Number of hours to allocate
      - Exceeding walltime time will automaticaly stop this job.
    cacheable: false
    widget: number_field
    max: 24
    min: 1
    step: 1
    value: 1
  bc_num_slots: 1
  num_cpus:
    id: num_cpus
    label: CPUs (Threads)
    help: Number of CPU threads
    cacheable: false
    widget: number_field
    max: 16
    min: 2
    step: 2
    value: 2
  num_mem:
    id: num_mem
    label: Memory (GB/Gigabytes)
    help: Total memory is available to all assigned threads!
    cacheable: false
    widget: number_field
    max: 64
    min: 1
    step: 1
    value: 2
  num_gpus:
    id: num_gpus
    label: "GPUs"
    help: "Number of GPU or Cuda devices"
    cacheable: false
    widget: number_field
    max: 2
    min: 0
    step: 1
    value: 0
  email:
    id: email
    label: Email Address
    help: |
      Enter your email address if you would like to receive job notifications (start, finished, failed, etc..).  Otherwise, leave the field empty.

      --------------------------
    cacheable: true
    widget: text_field
  singularity_img:
    id: singularity_img
    label: Singularity Container File
    help: |
      Select a Singularity Container (.sif/.simg) that includes R and RStudio Server.
    cacheable: false
    data-filepicker: true
    data-target-file-type: files
    data-target-file-pattern: '(.simg|.sif)$'
    data-default-directory: '/opt/apps/community/od_chsi_rstudio'
    readonly: true
    value: '/opt/apps/community/od_chsi_rstudio/2021-2022-rstudio-singularity-image-for-hiv_aids-test_v018.sif'

# TODO:
# Try to generate a list of accounts using the following
# sacctmgr list associations -P format=User,Account | grep -w josh